package com.gree.mall.manager.bean.common;

import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.gree.mall.manager.annotation.ZfireField;
import com.gree.mall.manager.plus.entity.CallRecord;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.Date;

@Data
@ZfireField(tbName = "a")
public class CallRecordOrderVo   {


    @ZfireField(hide = true)
    @TableId(value = "id", type = IdType.ID_WORKER_STR)
    private String id;

    @ApiModelProperty(value = "工单号")
    private String orderBaseId;

    @ApiModelProperty(value = "当时的工单状态")
    private String orderStatus;

    @ApiModelProperty(value = "呼叫方式")
    private String callType1;

    @ApiModelProperty(value = "通话类型")
    private String callType2;

    @ApiModelProperty(value = "师傅手机号")
    private String workerMobile;

    @ApiModelProperty(value = "通话发起时间")
    private Date startTime;

    @ApiModelProperty(value = "摘机接通时间")
    private Date start;

    @ApiModelProperty(value = "通话结束时间")
    private Date end;

    @ApiModelProperty(value = "客户手机号")
    private String phone;

    @ApiModelProperty(value = "师傅/信息员云呼信息")
    private String promoter;

    @ApiModelProperty(value = "回访成功/回访失败")
    private String status;

    @ApiModelProperty(value = "通话时长(秒)")
    private Integer callTimestamp;

    @ApiModelProperty(value = "振铃时长(秒)")
    private Integer ringTimestamp;

    @ApiModelProperty(value = "录音文件")
    private String fileUrl;

    @ApiModelProperty(value = "录音转文本")
    private String contentText;

    @ApiModelProperty(value = "原因描述")
    private String remark;

    @ApiModelProperty(value = "创建时间")
    @TableField(fill = FieldFill.INSERT)
    private Date createTime;

    @ApiModelProperty(value = "创建人")
    @TableField(fill = FieldFill.INSERT)
    private String createBy;


}
