package com.gree.mall.manager.controller.fadada;

import com.gree.mall.manager.annotation.ApiNotAuth;
import com.gree.mall.manager.helper.ResponseHelper;
import com.gree.mall.manager.logic.fadada.FDDNotifyLogic;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.RequiredArgsConstructor;
import org.springframework.integration.redis.util.RedisLockRegistry;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.Map;

@RequiredArgsConstructor
@RestController
@Api(value = "法大大回调通知API", tags ={"法大大回调通知API"} )
@RequestMapping("/fdd/notify")
public class NotifyController {

    private final FDDNotifyLogic fddNotifyLogic;
    private final RedisLockRegistry redisLockRegistry;

    @ApiNotAuth
    @RequestMapping("/company/ca/auth")
    @ApiOperation(value = "CA实名企业认证回调")
    public ResponseHelper<String> caCompanyAuthResultPost(@RequestParam Map<String, String> params) throws Exception {
        fddNotifyLogic.caCompanyAuthResult(params);
        return ResponseHelper.success();
    }

    @ApiNotAuth
    @RequestMapping("/company/ca/auth/auto")
    @ApiOperation(value = "CA实名企业授权自动签回调")
    public ResponseHelper<String> caCompanyAuthAutoResultPost(@RequestParam Map<String, String> params) throws Exception {
        fddNotifyLogic.caCompanyAuthAutoResult(params);
        return ResponseHelper.success();
    }

    @PostMapping("/find/company/auth/result")
    @ApiOperation(value = "CA实名企业结果查询")
    public ResponseHelper<String> findCompanyAuthResult(@RequestParam String transactionNo) throws Exception {
        fddNotifyLogic.queryCACompanyAuthResult(transactionNo);
        return ResponseHelper.success();
    }

}
